<?php
/*
Plugin Name: Framestr for WordPress
Description: Framestr for WordPress by Framestr, Inc. Adds various highly effective sign-up methods to your site.
Version: 1.0
Author: Framestr, Inc.
Author URI: URI: https://www.framestr.com
*/
if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}
//Define directory path
define( 'FS4WP_DIR_PATH', dirname(__FILE__).'/' );
define( 'FS4WP_URL_PATH', WP_PLUGIN_URL.'/'.plugin_basename( dirname(__FILE__) ).'/' );
//Include Comman function liabrary
include_once(FS4WP_DIR_PATH . 'includes/class_lib.php');
if(!class_exists('FS4WP')){
	class FS4WP {
		public function __construct(){
			/**
			 * Plugin url and dir path
			*/
			add_action( 'plugins_loaded', array( &$this, '_fs4wp_load_plugin' ) );
			/**
			* Load scripts and stylesheet on Framestr for WP Admin pages
			*/
			add_action( 'admin_enqueue_scripts', array( $this, '_fs4wp_enqueue_assets' ) );
			/**
			 * Register a Framestr menu page.
			*/
			add_action( 'admin_menu', array( &$this, '_fs4wp_my_menu_pages' ) );
			/**
			* create frame on the basis of shortcode
			**/
			add_shortcode('fs4wp', array( &$this,'_fs4wp_myframe_dymic_dta_func'));
			/**
			* add insert shortcode button while creating page
			**/
			add_action('media_buttons', array( &$this,'_fs4wp_add_srtcode_btn'));
			/**
			*create widgets
			**/			
			add_action('widgets_init', array( &$this,'_frmstr_wpb_load_widget'));
		}
		/**
		 * FS4WP URL and DIR Path.
		*/
		public function _fs4wp_load_plugin(){
			define( 'FS4WP_DIR_PATH', dirname(__FILE__).'/' );
			define( 'FS4WP_URL_PATH', WP_PLUGIN_URL.'/'.plugin_basename( dirname(__FILE__) ).'/' );
		}
		/**
		* Load scripts and stylesheet on Framestr for WP Admin pages
		*/
		public function _fs4wp_enqueue_assets(){
			// css
			wp_register_style( 'fs4wp-admin', FS4WP_URL_PATH . 'assets/css/admin-styles.css' );
			wp_enqueue_style( 'fs4wp-admin' );
			wp_enqueue_script('fs4wp-admin-js', FS4WP_URL_PATH . 'assets/js/frmstr_custom.js');
		}
		/**
		 * Register a Framestr menu page.
		*/
		function _fs4wp_my_menu_pages(){
			add_menu_page(
				__( 'Framestr for WP', 'framestr-for-wp' ),
				'Framestr for WP',
				'manage_options',
				'framestr-for-wp',
				array( $this, '_fs4wp_show_generals_setting_page' ),
				FS4WP_URL_PATH . 'assets/img/icon_16x16.png',
				'99'
			);
			add_submenu_page(
				'', 
				'Organization Details', 
				'Organization Details', 
				'manage_options', 
				'framestr-organization-details',
				array( $this, '_fs4wp_show_framestr_organization_details_page' ) 
			);
			add_submenu_page(
				'framestr-for-wp', 
				'Forms', 
				'Forms', 
				'manage_options', 
				'framestr-forms',
				array( $this, '_fs4wp_show_framestr_forms_page' ) 
			);
			add_submenu_page(
				'', 
				'Form Details', 
				'Form Details', 
				'manage_options', 
				'framestr-form-details',
				array( $this, '_fs4wp_show_framestr_form_details_page' ) 
			);
		}

		/**
		* Show the API Settings page
		*/
		public function _fs4wp_show_generals_setting_page() {
			require FS4WP_DIR_PATH . 'includes/views/general-settings.php';
		}
		
		/**
		* Show the API forms page
		*/
		public function _fs4wp_show_framestr_organizations_page() {
			require FS4WP_DIR_PATH . 'includes/views/framestr-organizations.php';
		}
		/**
		* Show the API form detsils
		*/
		public function _fs4wp_show_framestr_organization_details_page() {
			require FS4WP_DIR_PATH . 'includes/views/framestr-organization-details.php';
		}
		
		/**
		* Show the API forms page
		*/
		public function _fs4wp_show_framestr_forms_page() {
			require FS4WP_DIR_PATH . 'includes/views/framestr-forms.php';
		}
		/**
		* Show the API form detsils
		*/
		public function _fs4wp_show_framestr_form_details_page() {
			require FS4WP_DIR_PATH . 'includes/views/framestr-form-details.php';
		}
		
		public function _fs4wp_add_srtcode_btn() {
		    require FS4WP_DIR_PATH . 'includes/views/framestr-popup-form-srtcode.php';
		   
		}
		/**
		*execute shortcode
		**/
		public function _fs4wp_myframe_dymic_dta_func( $atts ){
			if ( ! empty( $atts['id'] ) ){
				/*fetch all forms*/
				$framestrApis = new framestrApis;
				$secret_key = '';
				// $responseArray = $framestrApis->formsList($secret_key);
				global $wpdb, $table_prefix;
				$framestr_args 		= "SELECT * FROM ".$table_prefix."posts WHERE post_type='fs4wp_key' AND post_password='fs4wp'";
				$framestr_post 		= $wpdb->get_row($framestr_args, 'ARRAY_A');
				$secret_key 		= get_post_field('frmstr_secret_key',$framestr_post['ID']);
				$organization_id 	= get_post_field('framestr_selected_organization',$framestr_post['ID']);
				$responseArray 		= $framestrApis->get_frmstr_form_by_organizationID($secret_key, $organization_id);
				foreach($responseArray['forms'] as $responseArrayVal){
					/*comapere forma with current id*/
					$form_id = $atts['id'];
					if($responseArrayVal['id']==$form_id){
						?>
						<iframe src="<?php echo $responseArrayVal['embed_url']; ?>" class="framestr-frame-leadform autoheight" scrolling="no" frameborder="0" style="width: 100%;height: 150px;"></iframe>
						<?php
					}
				}
			}
		}//myframe function end

		/**
		*register widget for shortcode
		**/
		function _frmstr_wpb_load_widget() {
			require FS4WP_DIR_PATH . 'includes/classes/Frmstr_add_widgets.php';
			
		}

	} // class end
	$FS4WP = new FS4WP();
		
}// class function check
wp_enqueue_script('fs4wp-admin-embed-js', 'https://forms.framestr.com/static/js/embed.js');
?>