<?php
class framestrApis{
	function organizationList($secretKey){
		if($secretKey){
			$response 		= file_get_contents('https://x:'.$secretKey.'@leadapp.framestr.com/api/1.0/organization/list');
			return $array 	= json_decode($response, true);
		}else{
			return '';
		}
	}
	function organizationsDetails($secretKey,$organizationId){
		if($secretKey){
			$response = file_get_contents('https://x:'.$secretKey.'@leadapp.framestr.com/api/1.0/organization/'.$organizationId);
			if($response){
				return $array = json_decode($response, true);
			}else{
				return '';
			}
		}else{
			return '';
		}
	}
	function formsList($secretKey){
        global $wpdb, $table_prefix;
        $framestr_args 	= "SELECT * FROM ".$table_prefix."posts WHERE post_type='fs4wp_key' AND post_password='fs4wp'";
    	$framestr_post 	= $wpdb->get_row($framestr_args, 'ARRAY_A');
    	$secret_key 	= get_post_field('frmstr_secret_key',$framestr_post['ID']);
		if($secret_key){
			$response = file_get_contents('https://x:'.$secret_key.'@leadapp.framestr.com/api/1.0/organization/4/forms');
			if ($response === false){
   				return false;
			}else{
				return $array = json_decode($response, true);
			}
		}else{
			return '';
		}
	}
	function formsDetails($secretKey,$formId){
		if($secretKey){
			$response = file_get_contents('https://x:'.$secretKey.'@leadapp.framestr.com/api/1.0/form/'.$formId);
			if($response){
				return $array = json_decode($response, true);
			}else{
				return '';
			}
		}else{
			return '';
		}
	}
	function updt_keys($framestr_secret_key){
		$keyData 		= $this->check_framestr_key_is_available();
		$frmstr_post 	= $keyData['frmstr_post'];
		if($keyData['frmstr_count']>0){
			$frmstr_post_id = $frmstr_post->ID;
		}else{
			$frmstr_keys = array(
				'post_type'		=>	'fs4wp_key',
				'post_title'	=>	'framestr_forms',
				'post_content'	=>	'Here is the Secret Key of Framestr',
				'post_status'	=>	'pending',
				'post_password'	=>	'fs4wp'
				);
			$frmstr_post_id = wp_insert_post($frmstr_keys);
		}
		update_post_meta($frmstr_post_id, 'frmstr_secret_key', $framestr_secret_key);
		return $frmstr_post_id;
	}
	function frmstr_dropdown_srtcode(){
		$framestr_post = $this->check_framestr_key_is_available();
		if($framestr_post['frmstr_count']>0){
			$secret_key = $this->get_framestr_secret_key($framestr_post);
		}
        $responseArray = $this->formsList($secret_key);
     	$opt = '';
     	foreach($responseArray['forms'] as $responseArrayVal){
        	$opt .= '<option value="'.$responseArrayVal['id'].'">'.$responseArrayVal['title'].'</option>';
        } 
        return $opt;  
	}
	function get_frmstr_form_by_organizationID($secretKey,$organizationId){
		$get_response = file_get_contents('https://x:'.$secretKey.'@leadapp.framestr.com/api/1.0/organization/'.$organizationId.'/forms');
		if($get_response===false){
			return $response = false;
		}else{
			return $response = json_decode($get_response, true);
		}

	}
	/**
    *check if secret key is insert or not
    **/
	function check_framestr_key_is_available(){
    	$args 					= array( 'post_type' => 'fs4wp_key', 'posts_per_page' => 1 );
    	$loop 					= new WP_Query( $args );
    	$frData['frmstr_post'] 	= current($loop->posts);
    	$frData['frmstr_count'] = $loop->post_count;
    	return $frData;
    }
    /**
    *get framestr secret key by passing framestr object,this object contains the key
    **/
    function get_framestr_secret_key($framestr_post){
    	$framestr_post 	= $framestr_post['frmstr_post'];
		$secret_key 	= get_post_field('frmstr_secret_key', $framestr_post);
		return $secret_key;
    }
}

	/*another class extend for list table*/
	if(!class_exists('WP_List_Table')){
		require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
	}
	class fs4wp_List_Table extends WP_List_Table{
			function __construct(){
				global $status, $page;
			//Set parent defaults
				parent::__construct( array(
				'singular'  => 'form',     //singular name of the listed records
				'plural'    => 'forms',    //plural name of the listed records
				'ajax'      => false        //does this table support ajax?
				) );
			}

		function column_default($item, $column_name){
			switch($column_name){
				case 'title':
				case 'rating':
				case 'director':
				case 'id':
				case 'embed_url':
				case 'share_url':
				case 'shortcode':
				return $item[$column_name];
				default:
                return print_r($item,true); //Show the whole array for troubleshooting purposes
            }
        }


        function get_columns(){
        	$columns = array(
        		'id'     		=> 'ID',
        		'title'     	=> 'Title',
        		'embed_url'     => 'Embed Url',
        		'share_url'    	=> 'Share Url',
        		'shortcode'  	=> 'Shortcode'
        		);
        	return $columns;
        }

        function get_sortable_columns() {
        	$sortable_columns = array(
            'title'     => array('title',false),     //true means it's already sorted
            'id'    	=> array('id',false),
            'director'  => array('director',false)
            );
        	return $sortable_columns;
        }

        function prepare_items($organization_id) {
        global $wpdb; //This is used only if making any database queries
		//Add paging varicalbes
        $per_page 	= 10;
        $columns 	= $this->get_columns();
        $hidden 	= array();
        $sortable 	= $this->get_sortable_columns();

        $this->_column_headers = array($columns, $hidden, $sortable);
        $framestrApis 	= new framestrApis; 
     	$framestr_post 	= $framestrApis->check_framestr_key_is_available();
        $secret_key 	= $framestrApis->get_framestr_secret_key($framestr_post);
        $responseArray 	= $framestrApis->get_frmstr_form_by_organizationID($secret_key, $organization_id);
        if(count($responseArray['forms'])<1){
        	$_SESSION['frmstr_error'] = true;
        	return false;
        }
        $i=0;
        foreach($responseArray['forms'] as $responseArrayVal){
        		$i++;
                $ifrm = '<iframe src="'.$responseArrayVal['embed_url'].'" 
 class="framestr-frame-leadform autoheight" scrolling="auto" frameborder="0" style="width: 100%; height: 420px;"></iframe>';

        	$data[$i]['id'] 		= $responseArrayVal['id'];
        	$data[$i]['title'] 		= $responseArrayVal['title'];
        	$data[$i]['embed_url'] 	= '<textarea cols=35 rows=10 disabled class="web_texarea">'.$ifrm.'</textarea>';  
            $data[$i]['share_url'] 	= '<a href='.$responseArrayVal['share_url'].' target="_BLANK">'.$responseArrayVal['share_url'].'</a>';
        	$data[$i]['shortcode'] 	= '[fs4wp id="'.$responseArrayVal['id'].'"]';
        }
        function usort_reorder($a,$b){
            $orderby 	= (!empty($_REQUEST['orderby'])) ? $_REQUEST['orderby'] : 'title'; //If no sort, default to title
            $order 		= (!empty($_REQUEST['order'])) ? $_REQUEST['order'] : 'asc'; //If no order, default to asc
            $result 	= strcmp($a[$orderby], $b[$orderby]); //Determine sort order
            return ($order==='asc') ? $result : -$result; //Send final sort direction to usort
        }
        	
        	
	    usort($data, 'usort_reorder');
	    $current_page 	= $this->get_pagenum();
	    $total_items 	= count($data);
	    $data 			= array_slice($data,(($current_page-1)*$per_page),$per_page);
	    $this->items 	= $data;
	    $this->set_pagination_args( array(
						'total_items' => $total_items,                  //WE have to calculate the total number of items
						'per_page'    => $per_page,                     //WE have to determine how many items to show on a page
						'total_pages' => ceil($total_items/$per_page)   //WE have to calculate the total number of pages
		));
    }
}