<?php
register_widget( 'frmstr_wpb_widget' );
class Frmstr_wpb_widget extends WP_Widget {
	function __construct() {
		parent::__construct(
			// Base ID of your widget
			'frmstr_wpb_widget', 
			// Widget name will appear in UI
			__('Framestr Forms', 'wpb_widget_domain'), 
			// Widget description
			array( 'description' => __( 'Add Framestr forms to your sidebar' ), ) 
			);
	}
	// Creating widget front-end
	public function widget( $args, $instance ) {
		$title = apply_filters( 'widget_title', $instance['title'] );
		// before and after widget arguments are defined by themes
		echo $args['before_widget'];
		if ( ! empty( $title ) )
			$args['before_title'] . $title . $args['after_title'];
		// This is where you run the code and display the output
		echo $instance["title"];
		if($instance["select_frmstr_forms"]!=""){
			do_shortcode('[fs4wp id="'.$instance["select_frmstr_forms"].'"]');
		}
	}
	// Widget Backend 
	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) {
			$title = $instance[ 'title' ];
			$select_frmstr_forms = $instance[ 'select_frmstr_forms' ];
		}else {
			$title = __( 'Form Title', 'wpb_widget_domain' );
		}
	// Widget admin form
		?>
		<p>
			<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
			<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<select id="<?php echo $this->get_field_id('select_frmstr_forms'); ?>" name="<?php echo $this->get_field_name('select_frmstr_forms'); ?>" class="widefat" style="width:100%;">
			<option value="">Select Framestr Form</option>
			<?php
			$framestrApis 		= new framestrApis; 
			$framestr_post 		= $framestrApis->check_framestr_key_is_available();
			$secret_key 		= $framestrApis->get_framestr_secret_key($framestr_post);
			$organization_id 	= get_post_field('framestr_selected_organization',$framestr_post['frmstr_post']->ID);
			$responseArray 		= $framestrApis->get_frmstr_form_by_organizationID($secret_key, $organization_id);
			foreach($responseArray['forms'] as $responseArrayVal) { ?>
			<option <?php selected( $instance['select_frmstr_forms'], $responseArrayVal['id'] ); ?> value="<?php echo $responseArrayVal['id']; ?>"><?php echo $responseArrayVal['title']; ?></option>
			<?php } ?>      
		</select>
		<?php 
	}
	// Updating widget replacing old instances with new
	public function update( $new_instance, $old_instance ) {
		$instance 			= array();
		$instance['title'] 	= ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
		$instance['select_frmstr_forms'] = ( ! empty( $new_instance['select_frmstr_forms'] ) ) ? strip_tags( $new_instance['select_frmstr_forms'] ) : '';
		return $instance;
	}
} // Class wpb_widget ends here
?>